program prioritasisor;
{prioritasi sor by Gyry Gbor, gyoryg@valerie.inf.elte.hu}
uses crt;
{maximum 255 elembl llhat}
const maxn=255;
      maxember=10000;
type
{felsorolsban a prioritsok}
Prioritas=(FrissenHazas,Kulfoldi,Hazai);
ElemTipus=record
           ErkezesiSzam:Integer;
           Protekcio:Prioritas;
           CsoportMeret:Integer;
           Mutato:0..maxn;
          end;
PrElemTipus=Array[1..maxn] of ElemTipus;
TarolasTipus=record
              csoport:1..maxn;
              protekcio:Prioritas;
             end;

{adatok vltozban lesznek az adatok}
var adatok:PrElemTipus;
    tarolas:Array[1..maxember] of TarolasTipus;
    fej:1..MaxN;
    emberszam,osszes:integer;
    db:integer;
{Kezdeti kp kiiratsa}
procedure Kezdet;
begin
 clrscr;
 textcolor(15);
 writeln('Prioritsi sor v1.3 (c) Gyry Gbor');
 writeln('---------------------------------------------------------------------');
end;


{adatok kiiratsa}
Procedure Kiiratas;
var i:integer;
    lep:0..maxn;
    kezdes:boolean;
begin
 lep:=fej;
 kezdes:=true;
 clrscr;
 writeln('Megrkezsek (csoportonknt lebontva):');
 repeat
   if not(kezdes) then lep:=adatok[lep].Mutato;
   if kezdes then kezdes:=false;
               case adatok[lep].Protekcio of
                 FrissenHazas: TextBackground(red);
                 Kulfoldi:  TextBackground(blue);
                 Hazai:TextBackground(green);
               end;
               write(adatok[lep].CsoportMeret);
               TextBackground(black);
               write(' ');
 until (adatok[lep].Mutato=0);
 TextBackground(black);
 TextColor(15);
 writeln;
 writeln(' piros - hzas');
 writeln(' kk - klfldi');
 writeln(' zld - hazai');
 writeln(' szm - csoportmret');
end;

{j adat besorolsa az adatok kz}
Procedure BeSorolas(sv:ElemTipus);
var lep,lastlep,last2lep:integer;
    megvan:boolean;
begin
 db:=sv.ErkezesiSzam;
if db<=maxn then
begin
 if db=1 then begin
               adatok[1]:=sv;
               adatok[1].Mutato:=0;
              end
              else
              begin
               lep:=fej;
                megvan:=false;
                 emberszam:=0;
                repeat
                 {utls lpsek elmentse}
                  last2lep:=lastlep;
                  lastlep:=lep;
                 {frissenhzasok helynek vizsglata}
                  if (sv.protekcio=FrissenHazas) and ((adatok[lep].Protekcio)<>FrissenHazas) then megvan:=true;
                 {kulfldiek helynek vizsglata}
                  if (sv.protekcio=Kulfoldi) and ((osszes div 2)<=emberszam) and not (adatok[lep].Protekcio=Kulfoldi)
                                                                                                        then megvan:=true;
                  if not(megvan) and (adatok[lep].Mutato<>0) then lep:=adatok[lep].Mutato;
                  if not(megvan) then emberszam:=emberszam+adatok[lep].CsoportMeret;
                until (adatok[lep].Mutato=0) or megvan;
                osszes:=osszes+sv.CsoportMeret;
                if (adatok[lep].Mutato=0) and not(megvan) then
                                         begin
                                           adatok[db]:=sv;
                                           adatok[lep].Mutato:=db;
                                           adatok[db].Mutato:=0;
                                         end;
                if (megvan) then
                              begin
                                if lastlep=fej then
                                                 begin
                                                  adatok[db]:=sv;
                                                  adatok[db].Mutato:=fej;
                                                  fej:=db;
                                                 end
                                               else
                                                 begin
                                                    adatok[db]:=sv;
                                                    adatok[db].Mutato:=adatok[last2lep].Mutato;
                                                    adatok[last2lep].Mutato:=db;
                                                 end;
                              end
                              else
                                begin
                                 adatok[db]:=sv;
                                 adatok[lep].Mutato:=db;
                                 adatok[db].Mutato:=0;
                                end;
              end;
              Kiiratas;
end
else writeln('Betelt a maximlis csoportszm !');
end;

{adatok beolvassa fjlbl}
Procedure BeOlvasFilebol;
var fajlnev:string;
    hiba:boolean;
    fajl:text;
    sv:elemtipus;
    c:char;
    db:integer;
begin
 repeat
  textcolor(15);
   hiba:=false;
    write('fjl neve:');
    readln(fajlnev);
   assign(fajl, fajlnev);
  {$I-}
   reset(fajl);
  {$I+}
  if IOResult <> 0 then
        begin
         hiba:=true;
         TextColor(4);
         writeln('HIBA! ',fajlnev,' fjlt nem lehet megnyitni! Prblj jra!');
        end;
 until not(hiba);
 db:=0;
  repeat
    db:=db+1;
    Readln(fajl,c);
    Readln(fajl,sv.Csoportmeret);
    case c of
      'f': sv.Protekcio:=FrissenHazas;
      'k': sv.Protekcio:=Kulfoldi;
      'h': sv.Protekcio:=Hazai;
    end;
    sv.ErkezesiSzam:=db;
     BeSorolas(sv);
     writeln;
     writeln('ssn valamit...');
     readkey;
  until eof(fajl);
end;

{beolvasas billen.rl}
Procedure BeOlvasBillentyurol;
var db:1..maxn;
    c,vanmeg:char;
    sv:elemtipus;
 begin
   db:=1;
   repeat
    clrscr;
    writeln(db,'. csoport adatai:');
  repeat
    write('tipusa: (f)frissenhzas (k) klfldi (h) hazai ?');
    Readln(c);
    c:=UpCase(c);
   until (c in ['F','K','H']);
    write('csopormrete ? ');
    Readln(sv.Csoportmeret);
    case c of
      'F': sv.Protekcio:=FrissenHazas;
      'K': sv.Protekcio:=Kulfoldi;
      'H': sv.Protekcio:=Hazai;
    end;
    sv.ErkezesiSzam:=db;
     BeSorolas(sv);
     write('Van mg adat? (i/n) ');
     readln(vanmeg);
     db:=db+1;
   until vanmeg<>'i';
end;


{beolvass}
Procedure BeOlvasas;
var c:char;
begin
 textcolor(15);
 repeat
    write('Beolvass fjlbl trtnik (i/n) ?');
    readln(c);
    c:=UpCase(c)
 until (c='I') or (c='N');
 if (c='I') then BeOlvasFilebol
            else BeOlvasBillentyurol;
end;

{csak a prioritast taroljuk}
Procedure AdatTarolas;
var i,sorszam:integer;
    lep:0..maxn;
    kezdes:boolean;
begin
 lep:=fej;
 kezdes:=true;
 sorszam:=0;
 writeln('Belpsi sorrend (emberekre lebontva):');
 repeat
   if not(kezdes) then lep:=adatok[lep].Mutato;
   if kezdes then kezdes:=false;
   for i:=1 to adatok[lep].CsoportMeret do
            begin
               sorszam:=sorszam+1;
               tarolas[sorszam].csoport:=adatok[lep].ErkezesiSzam;
               tarolas[sorszam].protekcio:=adatok[lep].Protekcio;
               case adatok[lep].Protekcio of
                 FrissenHazas: TextBackground(red);
                 Kulfoldi:  TextBackground(blue);
                 Hazai:TextBackground(green);
               end;
               write(adatok[lep].ErkezesiSzam);
               TextBackground(black);
               write(' ');
            end;
 until (adatok[lep].Mutato=0);
 TextBackground(black);
 TextColor(15);
 writeln;
 writeln(' piros - hzas');
 writeln(' kk - klfldi');
 writeln(' zld - hazai');
 writeln(' szm - rkezs (csoportszm)');
     writeln;
     writeln('ssn valamit...');
     readkey;

end;

begin
  fej:=1;
  osszes:=0;
  Kezdet;
  BeOlvasas;
  AdatTarolas;
  ReadKey;
end.